C $TITLE: 'MAIN2'
C $NOFLOATCALLS
C
      SUBROUTINE GWAVE (ERV,EZV,ERH,EZH,EPH)
C
C     GWAVE COMPUTES THE ELECTRIC FIELD, INCLUDING GROUND WAVE, OF A
C     CURRENT ELEMENT OVER A GROUND PLANE USING FORMULAS OF K.A.
C     NORTON (PROC. IRE, SEPT., 1937, PP.1203,1236.)
C
      REAL*8 PI,TPJX,R1,R2,ZMH,ZPH
      REAL*8 SPP,SPP2,SPPP,SPPP2,CPP,CPP2,CPPP,CPPP2
      COMPLEX*16 TPJ,FBAR,F,G,W,V,U,U2,XX1,XX2,RK1,RK2,T1,T2,T3,T4
      COMPLEX*16 X1,X2,X3,X4,X5,X6,X7,P1,RV,OMR,Q1,RH,XR1,XR2
      COMPLEX*16 ERV,EZV,ERH,EZH,EPH
      COMPLEX FJ,ECON
      COMMON/GWAV/ U,U2,XX1,XX2,R1,R2,ZMH,ZPH
      DIMENSION FJX(2),TPJX(2),ECONX(2)
      EQUIVALENCE (FJ,FJX),(TPJ,TPJX),(ECON,ECONX)
      DATA PI/3.141592654D0/,FJX/0.,1./,TPJX/0.,6.283185308D0/
      DATA ECONX/0.,-188.367/
C**
C     E      WRITE(*,*) '    GWAVE: START, ZMH=',ZMH,' ZPH=',ZPH
C**
      SPPP=ZMH/R1
      SPPP2=SPPP*SPPP
      CPPP2=1.D0-SPPP2
      IF (CPPP2.LT.1.D-20) CPPP2=1.D-20
      CPPP=DSQRT(CPPP2)
      SPP=ZPH/R2
      SPP2=SPP*SPP
      CPP2=1.-SPP2
      IF (CPP2.LT.1.D-20) CPP2=1.D-20
      CPP=DSQRT(CPP2)
      RK1=-TPJ*R1
      RK2=-TPJ*R2
      T1=1.-U2*CPP2
      T2=CDSQRT(1.D0*T1)
      T3=(1.-1./RK1)/RK1
      T4=(1.-1./RK2)/RK2
      P1=RK2*U2*T1/(2.*CPP2)
      RV=(SPP-U*T2)/(SPP+U*T2)
      OMR=1.-RV
      W=1./OMR
      W=(4.,0.)*P1*W*W
      F=FBAR(W)
      Q1=RK2*T1/(2.*U2*CPP2)
      RH=(T2-U*SPP)/(T2+U*SPP)
      V=1./(1.+RH)
      V=(4.,0.)*Q1*V*V
      G=FBAR(V)
      XR1=XX1/R1
      XR2=XX2/R2
      X1=CPPP2*XR1
      X2=RV*CPP2*XR2
      X3=OMR*CPP2*F*XR2
      X4=U*T2*SPP*2.*XR2/RK2
      X5=XR1*T3*(1.-3.*SPPP2)
      X6=XR2*T4*(1.-3.*SPP2)
      EZV=(X1+X2+X3-X4-X5-X6)*ECON
      X1=SPPP*CPPP*XR1
      X2=RV*SPP*CPP*XR2
      X3=CPP*OMR*U*T2*F*XR2
      X4=SPP*CPP*OMR*XR2/RK2
      X5=3.*SPPP*CPPP*T3*XR1
      X6=CPP*U*T2*OMR*XR2/RK2*.5
      X7=3.*SPP*CPP*T4*XR2
      ERV=-(X1+X2-X3+X4-X5+X6-X7)*ECON
      EZH=-(X1-X2+X3-X4-X5-X6+X7)*ECON
      X1=SPPP2*XR1
      X2=RV*SPP2*XR2
      X4=U2*T1*OMR*F*XR2
      X5=T3*(1.-3.*CPPP2)*XR1
      X6=T4*(1.-3.*CPP2)*(1.-U2*(1.+RV)-U2*OMR*F)*XR2
      X7=U2*CPP2*OMR*(1.-1./RK2)*(F*(U2*T1-SPP2-1./RK2)+1./RK2)*XR2
      ERH=(X1-X2-X4-X5+X6+X7)*ECON
      X1=XR1
      X2=RH*XR2
      X3=(RH+1.)*G*XR2
      X4=T3*XR1
      X5=T4*(1.-U2*(1.+RV)-U2*OMR*F)*XR2
      X6=.5*U2*OMR*(F*(U2*T1-SPP2-1./RK2)+1./RK2)*XR2/RK2
      EPH=-(X1-X2+X3-X4+X5+X6)*ECON
C**
C     E        WRITE(*,*) '    GWAV: RETURN'
C**
      RETURN
      END
C
C
C
      SUBROUTINE TBF (SI,BI,ICON1,ICON2,ICAP,I,LD)
C     COMPUTE BASIS FUNCTION I
      INTEGER*4 ICON1,ICON2,N1,N2,N,NP,M1,M2,M,MP,IPSYM
      REAL*8 PI,AX,BX,CX,D,SDH,CDH,SD,CD,OMC,AJ,PP,PM,QP,QM,XXI
      COMMON/DATAD/N1,N2,N,NP,M1,M2,M,MP,IPSYM,WLAM
      COMMON/SEGJ/AX(30),BX(30),CX(30),JCO(30),JSNO,ISCON(50),NSCON,
     1IPCON(10),NPCON
      DIMENSION SI(LD),BI(LD),ICON1(LD),ICON2(LD)
      DATA PI/3.141592654D0/,JMAX/30/
C**
C     E      WRITE(*,*) '   TBF: START'
C**
C**
      JSNO=0
      PP=0.
      JCOX=ICON1(I)
      IF (JCOX.GT.10000) JCOX=I
      JEND=-1
      IEND=-1
      SIG=-1.
      IF (JCOX) 1,10,2
1     JCOX=-JCOX
      GO TO 3
2     SIG=-SIG
      JEND=-JEND
3     JSNO=JSNO+1
      IF (JSNO.GE.JMAX) GO TO 28
      JCO(JSNO)=JCOX
      D=PI*SI(JCOX)
      SDH=DSIN(D)
      CDH=DCOS(D)
      SD=2.*SDH*CDH
      IF (D.GT.0.015) GO TO 4
      OMC=4.*D*D
      OMC=((1.3888889D-3*OMC-4.1666666667D-2)*OMC+.5)*OMC
      GO TO 5
4     OMC=1.-CDH*CDH+SDH*SDH
5     AJ=1./(DLOG(1.D0/(PI*BI(JCOX)))-.577215664D0)
      PP=PP-OMC/SD*AJ
      AX(JSNO)=AJ/SD*SIG
      BX(JSNO)=AJ/(2.*CDH)
      CX(JSNO)=-AJ/(2.*SDH)*SIG
      IF (JCOX.EQ.I) GO TO 8
      IF (JEND.EQ.1) GO TO 6
      JCOX=ICON1(JCOX)
      GO TO 7
6     JCOX=ICON2(JCOX)
7     IF (IABS(JCOX).EQ.I) GO TO 9
      IF (JCOX) 1,28,2
8     BX(JSNO)=-BX(JSNO)
9     IF (IEND.EQ.1) GO TO 11
10    PM=-PP
      PP=0.
      NJUN1=JSNO
      JCOX=ICON2(I)
      IF (JCOX.GT.10000) JCOX=I
      JEND=1
      IEND=1
      SIG=-1.
      IF (JCOX) 1,11,2
11    NJUN2=JSNO-NJUN1
      JSNOP=JSNO+1
      JCO(JSNOP)=I
      D=PI*SI(I)
      SDH=DSIN(D)
      CDH=DCOS(D)
      SD=2.*SDH*CDH
      CD=CDH*CDH-SDH*SDH
      IF (D.GT.0.015) GO TO 12
      OMC=4.*D*D
      OMC=((1.3888889D-3*OMC-4.1666666667D-2)*OMC+.5)*OMC
      GO TO 13
12    OMC=1.-CD
13    AP=1./(DLOG(1.D0/(PI*BI(I)))-.577215664D0)
      AJ=AP
      IF (NJUN1.EQ.0) GO TO 16
      IF (NJUN2.EQ.0) GO TO 20
      QP=SD*(PM*PP+AJ*AP)+CD*(PM*AP-PP*AJ)
      QM=(AP*OMC-PP*SD)/QP
      QP=-(AJ*OMC+PM*SD)/QP
      BX(JSNOP)=(AJ*QM+AP*QP)*SDH/SD
      CX(JSNOP)=(AJ*QM-AP*QP)*CDH/SD
      DO 14 IEND=1,NJUN1
      AX(IEND)=AX(IEND)*QM
      BX(IEND)=BX(IEND)*QM
14    CX(IEND)=CX(IEND)*QM
      JEND=NJUN1+1
      DO 15 IEND=JEND,JSNO
      AX(IEND)=-AX(IEND)*QP
      BX(IEND)=BX(IEND)*QP
15    CX(IEND)=-CX(IEND)*QP
      GO TO 27
16    IF (NJUN2.EQ.0) GO TO 24
      IF (ICAP.NE.0) GO TO 17
      XXI=0.
      GO TO 18
17    QP=PI*BI(I)
      XXI=QP*QP
      XXI=QP*(1.-.5*XXI)/(1.-XXI)
18    QP=-(OMC+XXI*SD)/(SD*(AP+XXI*PP)+CD*(XXI*AP-PP))
      D=CD-XXI*SD
      BX(JSNOP)=(SDH+AP*QP*(CDH-XXI*SDH))/D
      CX(JSNOP)=(CDH+AP*QP*(SDH+XXI*CDH))/D
      DO 19 IEND=1,NJUN2
      AX(IEND)=-AX(IEND)*QP
      BX(IEND)=BX(IEND)*QP
19    CX(IEND)=-CX(IEND)*QP
      GO TO 27
20    IF (ICAP.NE.0) GO TO 21
      XXI=0.
      GO TO 22
21    QM=PI*BI(I)
      XXI=QM*QM
      XXI=QM*(1.-.5*XXI)/(1.-XXI)
22    QM=(OMC+XXI*SD)/(SD*(AJ-XXI*PM)+CD*(PM+XXI*AJ))
      D=CD-XXI*SD
      BX(JSNOP)=(AJ*QM*(CDH-XXI*SDH)-SDH)/D
      CX(JSNOP)=(CDH-AJ*QM*(SDH+XXI*CDH))/D
      DO 23 IEND=1,NJUN1
      AX(IEND)=AX(IEND)*QM
      BX(IEND)=BX(IEND)*QM
23    CX(IEND)=CX(IEND)*QM
      GO TO 27
24    BX(JSNOP)=0.
      IF (ICAP.NE.0) GO TO 25
      XXI=0.
      GO TO 26
25    QP=PI*BI(I)
      XXI=QP*QP
      XXI=QP*(1.-.5*XXI)/(1.-XXI)
26    CX(JSNOP)=1./(CDH-XXI*SDH)
27    JSNO=JSNOP
      AX(JSNO)=-1.
C**
C     E      WRITE(*,*) '   TBF: RETURN'
C**
      RETURN
28    WRITE(*,29)  I
      STOP
C
29    FORMAT (43H TBF - SEGMENT CONNECTION ERROR FOR SEGMENT,I5)
      END
C
C
      FUNCTION ATGN2 (X,Y)
C
C     ATGN2 IS ARCTANGENT FUNCTION MODIFIED TO RETURN 0. WHEN X=Y=0.
C
      REAL*8 ATGN2,X,Y
      IF (X) 3,1,3
1     IF (Y) 3,2,3
2     ATGN2=0.
      RETURN
3     ATGN2=DATAN2(X,Y)
      RETURN
      END
C
C
C
      FUNCTION CANG (Z)
C
C     CANG RETURNS THE PHASE ANGLE OF A COMPLEX NUMBER IN DEGREES.
C
      REAL*8 CANG,ATGN2,DIMAG,DREAL
      COMPLEX*16 Z
      CANG=ATGN2(DIMAG(Z),DREAL(Z))*57.29577951D0
      RETURN
      END
C
C
C
      FUNCTION DB10 (X)
C
C     FUNCTION DB-- RETURNS DB FOR MAGNITUDE (FIELD) OR MAG**2 (POWER) I
C
      REAL*8 DB10,X
      F=10.
1     IF (X.LT.1.D-20) GO TO 2
      DB10=F*DLOG10(X)
      RETURN
2     DB10=-999.99D0
      RETURN
      END
C
C
C
      FUNCTION DB20 (X)
      REAL*8 DB20,X
      F=20.
1     IF (X.LT.1.D-20) GO TO 2
      DB20=F*DLOG10(X)
      RETURN
2     DB20=-999.99D0
      RETURN
      END
C
C
C
      LOGICAL FUNCTION ENF(NUNIT)
C*********** THIS ROUTINE NOT USED ON VAX **************
      NUNIT=NUNIT
C**
C     IF (EOF,NUNIT) 1,2
1     ENF=.TRUE.
      RETURN
2     ENF=.FALSE.
      RETURN
      END
C
C
C
      FUNCTION FBAR(P)
C
C     FBAR IS SOMMERFELD ATTENUATION FUNCTION FOR NUMERICAL DISTANCE P
C
      REAL*8 TOSP,SP,TMS,SMS
      COMPLEX*16 P,FBAR,Z,ZS,SUM,POW,TERM
      COMPLEX FJ
      DIMENSION FJX(2)
      EQUIVALENCE (FJ,FJX)
      DATA TOSP/1.128379167D0/,ACCS/1.E-12/,SP/1.772453851D0/,FJX/0.,1./
      Z=FJ*CDSQRT(P)
      IF (CDABS(Z).GT.3.D0) GO TO 3
C
C     SERIES EXPANSION
C
      ZS=Z*Z
      SUM=Z
      POW=Z
      DO 1 I=1,100
      POW=-POW*ZS/FLOAT(I)
      TERM=POW/(2.*I+1.)
      SUM=SUM+TERM
      TMS=DREAL(TERM*DCONJG(TERM))
      SMS=DREAL(SUM*DCONJG(SUM))
      IF (TMS/SMS.LT.ACCS) GO TO 2
1     CONTINUE
2     FBAR=1.-(1.-SUM*TOSP)*SP*Z*CDEXP(ZS)
      RETURN
C
C     ASYMPTOTIC EXPANSION
C
3     IF(DREAL(Z).GE.0.D0) GO TO 4
      MINUS=1
      Z=-Z
      GO TO 5
4     MINUS=0
5     ZS=.5/(Z*Z)
      SUM=DCMPLX(0.,0.)
      TERM=DCMPLX(1.,0.)
      DO 6 I=1,6
      TERM=-TERM*(2.*I-1.)*ZS
6     SUM=SUM+TERM
      IF (MINUS.EQ.1) SUM=SUM-2.*SP*Z*CDEXP(Z*Z)
      FBAR=-SUM
      RETURN
      END
C
C
C
      FUNCTION ISEGNO(ITAGI,MX,LD,ITAG)
C
C     ISEGNO RETURNS THE SEGMENT NUMBER OF THE MTH SEGMENT HAVING THE
C     TAG NUMBER ITAGI.  IF ITAGI=0 SEGMENT NUMBER M IS RETURNED.
C
      INTEGER*4 ITAG,N1,N2,N,NP,M1,M2,M,MP,IPSYM
      COMMON/DATAD/N1,N2,N,NP,M1,M2,M,MP,IPSYM,WLAM
      DIMENSION ITAG(LD)
C**
      IF (MX.GT.0) GO TO 1
      WRITE(*,6)
      STOP
1     ICNT=0
      IF (ITAGI.NE.0) GO TO 2
      ISEGNO=MX
      RETURN
2     IF (N.LT.1) GO TO 4
      DO 3 I=1,N
      IF (ITAG(I).NE.ITAGI) GO TO 3
      ICNT=ICNT+1
      IF (ICNT.EQ.MX) GO TO 5
3     CONTINUE
4     WRITE(*,7)  ITAGI
      STOP
5     ISEGNO=I
      RETURN
C
6     FORMAT (4X,91HCHECK DATA, PARAMETER SPECIFYING SEGMENT POSITION IN
     1 A GROUP OF EQUAL TAGS MUST NOT BE ZERO)
7     FORMAT (///,10X,'NO SEGMENT HAS AN ITAG OF ',I5)
      END
C
C
C
      SUBROUTINE BLCKOT(AR,IX1,IX2,NBLKS,NEOF,NUNIT)
C
C     BLCKOT CONTROLS THE READING AND WRITING OF MATRIX BLOCKS ON FILES
C     FOR THE OUT-OF-CORE MATRIX SOLUTION.
C
      INTEGER*4 IX1,IX2,I1,I2,J
CLARGE: AR
      COMPLEX AR(1)
C**
C     E      WRITE(*,*) '     BLCKOT: START, IX1=',IX1,' IX2=',IX2
C**
      NBLKS=NBLKS
      NEOF=NEOF
C**
      I1=(IX1+1)/2
      I2=(IX2+1)/2
1     WRITE (NUNIT) (AR(J),J=I1,I2)
C**
C     E      WRITE(*,*) '     BLCKOT: RETURN'
C**
      RETURN
      END
C
C
C
      SUBROUTINE BLCKIN(AR,IX1,IX2,NBLKS,NEOF,NUNIT)
      LOGICAL ENF
      INTEGER*4 IX1,IX2,I1,I2,J
CLARGE: AR
      COMPLEX AR(1)
C**
C     E      WRITE(*,*) '     BLCKIN: START, IX1=',IX1,' IX2=',IX2
C**
      I1=(IX1+1)/2
      I2=(IX2+1)/2
      DO 2 I=1,NBLKS
      READ (NUNIT,END=3) (AR(J),J=I1,I2)
C     IF (ENF(NUNIT)) GO TO 3
2     CONTINUE
C**
C     E      WRITE(*,*) '     BLCKIN: RETURN AFTER 2'
C**
      RETURN
3     WRITE(*,4)  NUNIT,NBLKS,NEOF
      IF (NEOF.NE.777) STOP
      NEOF=0
C**
C     E      WRITE(*,*) '     BLCKIN: RETURN AFTER 3'
C**
      RETURN
C
4     FORMAT (13H  EOF ON UNIT,I3,9H  NBLKS= ,I3,8H  NEOF= ,I5)
      END
C
C
      SUBROUTINE SECOND(X)
C      INTEGER*4 IHR,IMIN,ISEC,I100TH
C      CALL GETTIM (IHR,IMIN,ISEC,I100TH)
C      X=IHR*3600 + IMIN*60 + ISEC + I100TH*.01
      RETURN
      END
